{ Projeto para exportao de dados para arquivo Texto
  via instruo SQL para os bancos de dados Interbase e Firebird
  Referente a matria de Revista - Andr - Suporte tcnico THE CLUB }
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, IBCustomDataSet, IBQuery, IBDatabase, ComCtrls,
  Grids, DBGrids, ExtCtrls, DBCtrls;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Label2: TLabel;
    Edt_ArqTxt: TEdit;
    Button3: TButton;
    Memo_Log: TMemo;
    Edit_Separador: TEdit;
    Check_Cabec: TCheckBox;
    Memo_SQL: TMemo;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Button1: TButton;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure UsaIBQuery(cSQL, cMsg: String; cExec: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses Unit2;
{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
begin
  IBDataBase1.Open;
  IBTransaction1.Active := True;
  { path e nome do arquivo texto a ser gerado }
  Edt_ArqTxt.Text := ExtractFilePath(Application.ExeName)+'EXPORTAR.TXT';
end;

procedure TForm1.UsaIBQuery(cSQL, cMsg: String; cExec: Boolean);
begin
  StatusBar1.SimpleText := cMsg;
  try
    IBQuery1.Close;
    IBQuery1.SQL.Text := cSQL;
    { Apresenta a instruo que ser executada na IBQuery }
    Memo_Log.Lines.Add( '======='+cMsg+'========' );
    Memo_Log.Lines.Add( IBQuery1.SQL.Text );
    Memo_Log.Lines.Add( '' );
    if cExec then
    begin
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
    end
    else
      IBQuery1.Open;
  except on E: EDataBaseError do
    begin
      ShowMessage('Erro: '+cMsg
                  +#13+'Original: '+E.Message);
      Form1.Panel1.Enabled := True;
      IBTransaction1.Rollback;
      Abort;
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var nArqTxt, nArqInt, cCabecalho, cScript : string;
    nTam, i: INTEGER;
    nTabCriada: Boolean;
begin
  try
    Panel1.Enabled := False;

    { Nome da tabela externa criada dentro do banco }
    nArqInt := 'TABEXPORTA';

    { limpa as variveis strings onde sero armazenadas a estrutura da tabela }
    nTabCriada := False;
    cCabecalho := ''; { Nome dos campos incluidos no cabecalho do texto }
    nTam := 0; { Tamanho de cada campo a ser exportado }
    cScript := ''; { Script para gerar a tabela externa }

    { nome do arquivo texto a ser gerado }
    nArqTxt := UpperCase( Edt_ArqTxt.Text );
    { se o arquivo texto j existe, apaga o arquivo }
    if FileExists( nArqTxt ) then
      DeleteFile( nArqTxt );

    { Instruo que ir ler a instruo SQL colocada pelo usurio no Memo_SQL }
    UsaIBQuery(Memo_SQL.Text, 'Lendo estrutura da tabela de origem', False);

    StatusBar1.SimpleText := ' Montando estrutura da tabela externa ';
    { l a estrutura da origem para gerar o arquivo texto de destino }
    for i:=0 to IBQuery1.Fields.Count-1 do
    begin
      Case IBQuery1.Fields[i].DataType of
        ftString:  nTam := IBQuery1.Fields[i].DataSize;
        ftSmallint, ftInteger, ftWord: nTam := 8;
        ftFloat, ftCurrency, ftBCD: nTam := 20;
        ftDate, ftTime: nTam := 11;
        ftDateTime: nTam := 20;
      end;
      { Se o tamanho do nome do campo for maior que nTam encontrado,
       ento deixa o nTam do tamanho do nome do campo }
      if Length( IBQuery1.Fields[i].FieldName ) > nTam then
        nTam := Length( IBQuery1.Fields[i].FieldName );

      {inclui a vrgula entre os campos do script}
      if cScript <> '' then
        cScript := cScript +',';

      { o usurio indicou que precisa do cabealho no arquivo texto }
      if (Check_Cabec.Checked) and (cCabecalho <> '') then
      begin
        { inclui o separador de campos definido pelo usurio }
        if Trim(Edit_Separador.Text) <> '' then
          cCabecalho := cCabecalho + '||'+QuotedStr(' '+Edit_Separador.Text+' ');
        cCabecalho := cCabecalho + ',';
      end;

      cCabecalho := cCabecalho + QuotedStr( UpperCase( IBQuery1.Fields[i].FieldName ) );

      cScript := cScript + UpperCase( IBQuery1.Fields[i].FieldName ) + ' CHAR( '+inttostr(ntam+4)+' ) ';

      Application.ProcessMessages;
    end;

    { Define o incio do script para criao da tabela externa }
    cScript := 'CREATE TABLE '+nArqInt+' EXTERNAL FILE '+QuotedStr(nArqTxt)+' ( '+cScript;
    { Define o final do script para criao da tabela externa
      incluimos o caracter de quebra de linha }
    cScript := cScript + ', QUEBRA CHAR(2) ) ';

    { Registra a tabela externa dentro do banco de dados }
    UsaIBQuery(cScript, 'Criando tabela externa', True);

    nTabCriada := True;

    if (Check_Cabec.Checked) then
    begin
      cScript := ' INSERT INTO '+nArqInt+
                 ' SELECT '+cCabecalho+','+QuotedStr(#13#10)+' FROM RDB$DATABASE';

      { Exportando cabealho para a tabela externa }
      UsaIBQuery(cScript, 'Exportando cabealho para a tabela externa', True);
    end;

    { Monta o script de insert que ir exportar os dados para o arquivo texto }
    { Pega o SQL do incio at o FROM }
    cScript := Copy(Memo_SQL.Text, 1, Pos('FROM', Memo_SQL.Text)-1);

    { Inclui os separadores nos campos caso o usurio tenha definido }
    if Trim(Edit_Separador.Text) <> '' then
      cScript := StringReplace(cScript,',','||'+QuotedStr(' '+Edit_Separador.Text+' ')+',',[rfReplaceAll]);

    cScript := cScript + ' , ' + QuotedStr(#13#10)+' ';

    { Pega o SQL do FROM at o Fim }
    cScript := cScript + Copy(Memo_SQL.Text, Pos('FROM', Memo_SQL.Text), Length(Memo_SQL.Text));

    { Exportando dados para o arquivo texto }
    cScript := ' INSERT INTO '+nArqInt+' '+cScript;
    UsaIBQuery(cScript, 'Exportando dados para a tabela externa', True);

    StatusBar1.SimpleText := 'Exportao concluida';  Panel1.Enabled := True;
  finally
    if nTabCriada then
    begin
      { apaga o registro de dentro do banco de dados }
      cScript := 'DROP TABLE '+nArqInt;
      UsaIBQuery(cScript, 'Excluindo registro da tabela externa do banco', True);
    end;
    { fecha todas as conexes }
    StatusBar1.SimpleText := 'Fechando o acesso ao banco de dados';
    IBQuery1.Close;
  end;
  { visualiza o arquivo txt }
  if FileExists( nArqTxt ) then
  begin
    Form2.Memo_Arquivo.Lines.LoadFromFile( nArqTxt );
    Form2.ShowModal;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  { visualiza o arquivo txt }
  if FileExists( UpperCase( Edt_ArqTxt.Text ) ) then
  begin
    Form2.Memo_Arquivo.Lines.LoadFromFile( UpperCase( Edt_ArqTxt.Text ) );
    Form2.ShowModal;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  { Fecha as conexo com o banco de dados }
  IBTransaction1.Active := False;
  IBDataBase1.Close;
end;

end.
